#include "ModuleParameter.h"

namespace mdd {
    ModuleParameter::ModuleParameter() {
        json default_val;
        default_val["value"] = 1;
        addInput("Value", default_val);
        addOutput("Value", default_val);
        setType("Parameter");
    }

    state ModuleParameter::update() {
        json ret = getInput(0)->getValue()["value"];
        getOutput(0)->resetState();
        if (ret.dump() != getOutput(0)->getValue()["value"].dump()) {
            getOutput(0)->getValueInternal()["value"] = ret;
        }
        return getOutput(0)->getState();
    }
}