#include "ModuleSwitch.h"
#include <iostream>

namespace mdd{
    ModuleSwitch::ModuleSwitch(){
        json default_val;
        default_val["value"] = { 42 };
        addInput("Switch", default_val);
        addInput("Value", default_val);
        addInput("Default", default_val);
        addOutput("Value", default_val);
        setType("Switch");
    }
    state ModuleSwitch::update(){
        json ret;
        size_t length = 1;
        if (getInput(0)->getValue()["value"].is_array()) {
            length = getInput(0)->getValue()["value"].size();
        }
        for (size_t i = 0; i < length; i++)
        {
            int index;
            if (getInput(0)->getValue()["value"].is_array()) {
                index = getInput(0)->getValue()["value"][i];
            }
            else {
                index = getInput(0)->getValue()["value"].get<int>();
            }
           
            if (index == 0) {
                index = 1;
            }

            if (index > getInputs().size() - 1) {
                index = getInputs().size() - 1;
            }

            if (getInput(0)->getValue()["value"].is_array()) {
                ret.push_back(getInput(index)->getValue()["value"]);
            }
            else {
                ret = getInput(index)->getValue()["value"];
            }
        }
        getOutput(0)->resetState();
        if (ret.dump() != getOutput(0)->getValue()["value"].dump()) {
            getOutput(0)->getValueInternal()["value"] = ret;
        }
        
        return getOutput(0)->getState();

    }
}