#ifndef MDD_IOUTPUT_H
#define MDD_IOUTPUT_H
#include "json.hpp"
#include <memory>
#include "IUnique.h"
#include "IState.h"
//#include "IInput.h"
#include "IConnector.h"

namespace mdd
{
    class IInput;
    class IModule;

    class IOutput : public IUnique, public IState, public IConnector<IInput>{
    public:
        virtual const json& getValue() = 0;
        virtual json& getValueInternal() = 0;
        virtual std::vector<std::shared_ptr<IInput>> getConnections() = 0;
        virtual ~IOutput() = default;
    };
}

#endif //MDD_IOUTPUT_H
